Subject: Re: ICMP packets - ll_temac with Microblaze

From: Michael Wang <[email-masked]>
Date: Thu, 22 Dec 2011 18:32:36 +0800

On 12/21/2011 06:11 PM, Michal Simek wrote:

> Hi Eric and David,
> 
> I have found one problem with ll_temac driver and
> this commit: net: more accurate skb truesize
> sha1: 87fb4b7b533073eeeaed0b6bf7c2328995f6c075
> 
> The problem is only with icmp packets from the target. It is sent and
> driver receive it
> but it is not proceed to the application.
> 

Hi, Michal

What's the type of icmp you are using? such as "EchoReps", we can find
the actually handler routine by this type.

And you said the packet already received by driver, can you tell me the
way you used to confirm this?

And have you checked when was the icmp packet being dropped, is it in
icmp_rcv or before or later?

Thanks,
Michael Wang

> The problem I see is that kmalloc_node_track_caller allocate
> specific size and then this size is changed by
> SKB_WITH_OVERHEAD(ksize(data)).
> The problem is with netdev_alloc_skb_ip_align which calls __alloc_skb
> function.
> 
> Currently driver uses setting for jumbo frames (9k). When I change it to
> use mtu (1,5k) then
> everything is ok.
> 
> Can you give me some hints what can be wrong?
> 
> Thanks,
> Michal
> 
>